#ifndef DECL_H
#define DECL_H

//++++ Gave a quick review. Looks like this is mostly my code. Plus, given its
// nature, it is likely to have been tested. Matches nBMSL version: Sekar

#ifdef __DEBUG__ASL__
  #define dbgprt(x) cout << x;
  #define dbgprtln(x,y) cout << x << y << endl; 
#else
  #define dbgprt(x) 
  #define dbgprtln(x,y)
#endif

#include <iostream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <vector>
#include <list>
#include <map>

using namespace std;

#include <stdio.h>
extern int yysymflags, yylineno, yycolumnno, 
           tokBegLn, tokEndLn, tokBegCol, tokEndCol, extSym;
extern int errTokBegLn, errTokEndLn, errTokBegCol, errTokEndCol;
extern const char* yyfilename;
extern FILE *yyin;

extern void yyerror(const char *);
extern int yyparse(void);
extern int yylex(void);

#define step " "; 
const int STEP_INDENT = 3;

inline void prtSpace(ostream& os, int n) {
  for (int i = 0; i < n; i++)
    os << step;
}

inline void prtTab(ostream& os, int n) {
  for (int i=0; i < n ; i++)
    os << "\t";
}

inline void prtln(ostream& os, int n) {
  os << endl; prtSpace(os, n);
}

inline void endln(ostream& os, int n) {
  os << ';'; prtln(os, n);
}

inline void prtRewind(ostream& os, int n, int m) {
   long pos = os.tellp();
   if (pos < 0)
      prtln(os, m);
   else os.seekp(pos-n);
}
#endif
